
#include <stdio.h>
#include <unistd.h>
#include "pcap.h"


int writePcapHeader(int fd, int linktype, int thiszone, int snaplen)
{
   struct pcap_file_header hdr;

   hdr.magic = TCPDUMP_MAGIC;
   hdr.version_major = PCAP_VERSION_MAJOR;
   hdr.version_minor = PCAP_VERSION_MINOR;

   hdr.thiszone = thiszone;
   hdr.snaplen = snaplen;
   hdr.sigfigs = 0;
   hdr.linktype = linktype;

   if (write(fd, &hdr, sizeof(hdr)) != sizeof(hdr)) {
      return (-1);
   }
   return (0);
}

/*
 * Output a packet to the initialized dump file.
 */
void writePcapPacket(int fd, const struct pcap_pkthdr *h, const unsigned char *sp)
{
   /* XXX we should check the return status */
   write(fd, h, sizeof(*h));
   write(fd, sp, h->caplen);
}

static int snaplen;

int readPcapHeader(int fd, struct pcap_file_header *h)
{
   struct pcap_file_header hdr;
   int r = read(fd, h, sizeof(*h));
   if (r != sizeof(*h)) {
      return -1;
   }

   if (h->magic != TCPDUMP_MAGIC && 
       h->magic != PATCHED_TCPDUMP_MAGIC) return -1;
//   h->version_major = PCAP_VERSION_MAJOR;
//   h->version_minor = PCAP_VERSION_MINOR;
   snaplen = h->snaplen;
//   hdr.thiszone = thiszone;
//   h->sigfigs = 0;
//   if (h->linktype != LINKTYPE_IEEE802_11) return -1;

   return h->linktype;
}

/*
 * Output a packet to the initialized dump file.
 */
int readPcapPacket(int fd, struct pcap_pkthdr *h, char *sp, int max)
{
   /* XXX we should check the return status */
   int r;
   read(fd, h, sizeof(*h));
   r = read(fd, sp, snaplen < h->caplen ? snaplen : h->caplen);
   return r;
}
